
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InvoicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.create(
            {
                id: data.id || undefined,
        
        invoice_number: data.invoice_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        issued_at: data.issued_at
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        subtotal_amount: data.subtotal_amount
        ||
        null
            ,
            
        tax_amount: data.tax_amount
        ||
        null
            ,
            
        total_amount: data.total_amount
        ||
        null
            ,
            
        balance_due: data.balance_due
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        bill_to_name: data.bill_to_name
        ||
        null
            ,
            
        bill_to_address: data.bill_to_address
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invoices.setTenant( data.tenant || null, {
            transaction,
        });
        
        await invoices.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await invoices.setReservation( data.reservation || null, {
            transaction,
        });
        

        
        await invoices.setLine_items(data.line_items || [], {
            transaction,
        });
        
        await invoices.setPayments(data.payments || [], {
            transaction,
        });
        
        await invoices.setDocuments(data.documents || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.invoices.getTableName(),
                belongsToColumn: 'pdf_file',
                belongsToId: invoices.id,
            },
            data.pdf_file,
            options,
        );
        

        return invoices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invoicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                invoice_number: item.invoice_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                issued_at: item.issued_at
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                subtotal_amount: item.subtotal_amount
            ||
            null
            ,
            
                tax_amount: item.tax_amount
            ||
            null
            ,
            
                total_amount: item.total_amount
            ||
            null
            ,
            
                balance_due: item.balance_due
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                bill_to_name: item.bill_to_name
            ||
            null
            ,
            
                bill_to_address: item.bill_to_address
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invoices = await db.invoices.bulkCreate(invoicesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < invoices.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.invoices.getTableName(),
                    belongsToColumn: 'pdf_file',
                    belongsToId: invoices[i].id,
                },
                data[i].pdf_file,
                options,
            );
        }
        

        return invoices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const invoices = await db.invoices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.invoice_number !== undefined) updatePayload.invoice_number = data.invoice_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.issued_at !== undefined) updatePayload.issued_at = data.issued_at;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.subtotal_amount !== undefined) updatePayload.subtotal_amount = data.subtotal_amount;
        
        
        if (data.tax_amount !== undefined) updatePayload.tax_amount = data.tax_amount;
        
        
        if (data.total_amount !== undefined) updatePayload.total_amount = data.total_amount;
        
        
        if (data.balance_due !== undefined) updatePayload.balance_due = data.balance_due;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.bill_to_name !== undefined) updatePayload.bill_to_name = data.bill_to_name;
        
        
        if (data.bill_to_address !== undefined) updatePayload.bill_to_address = data.bill_to_address;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await invoices.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await invoices.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organization !== undefined) {
            await invoices.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.reservation !== undefined) {
            await invoices.setReservation(
              
              data.reservation,
              
              { transaction }
            );
        }
        

        
        
        if (data.line_items !== undefined) {
            await invoices.setLine_items(data.line_items, { transaction });
        }
        
        if (data.payments !== undefined) {
            await invoices.setPayments(data.payments, { transaction });
        }
        
        if (data.documents !== undefined) {
            await invoices.setDocuments(data.documents, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.invoices.getTableName(),
                belongsToColumn: 'pdf_file',
                belongsToId: invoices.id,
            },
            data.pdf_file,
            options,
        );
        

        return invoices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invoices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invoices) {
                await record.destroy({transaction});
            }
        });


        return invoices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findByPk(id, options);

        await invoices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invoices.destroy({
            transaction
        });

        return invoices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findOne(
            { where },
            { transaction },
        );

        if (!invoices) {
            return invoices;
        }

        const output = invoices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice_line_items_invoice = await invoices.getInvoice_line_items_invoice({
            transaction
        });
        
        
        output.payments_invoice = await invoices.getPayments_invoice({
            transaction
        });
        
        
        output.documents_invoice = await invoices.getDocuments_invoice({
            transaction
        });
        
        
        
        
        output.activity_comments_invoice = await invoices.getActivity_comments_invoice({
            transaction
        });
        
        
        
        
        
        
        output.tenant = await invoices.getTenant({
            transaction
        });
        
        
        output.organization = await invoices.getOrganization({
            transaction
        });
        
        
        output.reservation = await invoices.getReservation({
            transaction
        });
        
        
        output.pdf_file = await invoices.getPdf_file({
            transaction
        });
        
        
        output.line_items = await invoices.getLine_items({
            transaction
        });
        
        
        output.payments = await invoices.getPayments({
            transaction
        });
        
        
        output.documents = await invoices.getDocuments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.reservations,
        as: 'reservation',
        
        where: filter.reservation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reservation.split('|').map(term => Utils.uuid(term)) } },
            {
              reservation_code: {
                [Op.or]: filter.reservation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.invoice_line_items,
        as: 'line_items',
        required: false,
      },

      {
        model: db.payments,
        as: 'payments',
        required: false,
      },

      {
        model: db.documents,
        as: 'documents',
        required: false,
      },


      {
        model: db.file,
        as: 'pdf_file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.invoice_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'invoice_number',
                        filter.invoice_number,
                    ),
                };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            
            if (filter.bill_to_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'bill_to_name',
                        filter.bill_to_name,
                    ),
                };
            }
            
            if (filter.bill_to_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'bill_to_address',
                        filter.bill_to_address,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.issued_atRange) {
                const [start, end] = filter.issued_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotal_amountRange) {
                const [start, end] = filter.subtotal_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_amountRange) {
                const [start, end] = filter.tax_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amountRange) {
                const [start, end] = filter.total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.balance_dueRange) {
                const [start, end] = filter.balance_dueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      


      if (filter.line_items) {
        const searchTerms = filter.line_items.split('|');

        include = [
          {
            model: db.invoice_line_items,
            as: 'line_items_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  description: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }

      if (filter.payments) {
        const searchTerms = filter.payments.split('|');

        include = [
          {
            model: db.payments,
            as: 'payments_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  reference: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }

      if (filter.documents) {
        const searchTerms = filter.documents.split('|');

        include = [
          {
            model: db.documents,
            as: 'documents_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  file_name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invoices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invoices',
                        'invoice_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invoices.findAll({
            attributes: [ 'id', 'invoice_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['invoice_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.invoice_number,
        }));
    }

    
};

